"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "Slot", {
  enumerable: true,
  get: function get() {
    return _Slot.default;
  }
});
exports.connect = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = require("react");

var _reactDom = require("react-dom");

var _shortid = _interopRequireDefault(require("shortid"));

var _Slot = _interopRequireDefault(require("./Slot"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

// 初始化接线板
var initDistributionBox = function initDistributionBox() {
  var _window = window,
      _powerStrip = _window._powerStrip; // 如果没有接线板就初始化一个

  if (!_powerStrip) {
    window._powerStrip = {
      firstPowerOn: function firstPowerOn(componentId, params, el) {
        var _window2 = window,
            _powerStrip = _window2._powerStrip;
        var wireBundles = _powerStrip.wireBundles;
        var wireBundle = wireBundles[componentId];
        var currentComponent; // 获取组件

        if (wireBundle) {
          var component = wireBundle.component;
          currentComponent = component;
        } // 渲染组件到dom上


        var uniqueId = _shortid.default.generate();

        if (currentComponent) {
          var wires = wireBundle.wires;
          (0, _reactDom.render)((0, _react.createElement)(currentComponent, _objectSpread({}, params, {
            ref: function ref(r) {
              wires[uniqueId] = r.updateState;
            }
          })), el);
          return uniqueId;
        }
      },
      powerOn: function powerOn(componentId, uniqueId, params) {
        var _window3 = window,
            _powerStrip = _window3._powerStrip;
        var wireBundles = _powerStrip.wireBundles;

        if (wireBundles[componentId] && wireBundles[componentId].wires && typeof wireBundles[componentId].wires[uniqueId] === 'function') {
          wireBundles[componentId].wires[uniqueId](params);
        }
      },
      wireBundles: {}
    };
  }
};

initDistributionBox();
/**
   * 增加需要渲染的组件
   * @param { string } componentId 需要渲染的组件的唯一标识
   * @param { element } component 需要渲染的组件
   */

var connect = function connect(componentId, containerDom, componentProps, children) {
  return function (component) {
    var _window4 = window,
        powerStripConfig = _window4.powerStripConfig;

    var _ref = powerStripConfig || {},
        active = _ref.active,
        exclude = _ref.exclude; // 以下情况组件不接入接线板
    // 没有接线板配置
    // 配置接线板后，没有激活
    // 接线板激活后，该组件被排除


    if (!powerStripConfig || !active || exclude instanceof Array && exclude.some(function (item) {
      return item === componentId;
    })) {
      if (containerDom) {
        (0, _reactDom.render)((0, _react.createElement)(component, componentProps, children), containerDom);
      }

      return component;
    }

    var TargetPlug =
    /*#__PURE__*/
    function (_PureComponent) {
      (0, _inherits2.default)(TargetPlug, _PureComponent);

      function TargetPlug(props) {
        var _this;

        (0, _classCallCheck2.default)(this, TargetPlug);
        _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(TargetPlug).call(this));
        _this.state = _objectSpread({}, props);
        _this.updateState = _this.updateState.bind((0, _assertThisInitialized2.default)(_this));
        return _this;
      }

      (0, _createClass2.default)(TargetPlug, [{
        key: "updateState",
        value: function updateState() {
          var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
          this.setState(_objectSpread({}, params));
        }
      }, {
        key: "render",
        value: function render() {
          return (0, _react.createElement)(component, _objectSpread({}, this.state));
        }
      }]);
      return TargetPlug;
    }(_react.PureComponent);

    ;
    var _window5 = window,
        _powerStrip = _window5._powerStrip;
    var wireBundles = _powerStrip.wireBundles;

    if (!wireBundles[componentId]) {
      wireBundles[componentId] = {
        component: TargetPlug,
        wires: []
      };
    }
  };
};

exports.connect = connect;